#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast")

#define cerr if(0) cout

using namespace std;
using LL = long long;
using LD = long double;
using PLD = pair<LD,LD>;
using PLL = pair<LL,LL>;

const LD PI = acosl(-1);
const LD EPS = 1e-9;

template<class T>
T dotProduct(pair<T,T>a, pair<T,T> b)
{
    return a.first * b.first + a.second * b.second;
}

template<class T>
T crossProduct(pair<T,T>a, pair<T,T> b)
{
    return a.first * b.second - a.second * b.first;
}


template<class T>
T lengthPow(pair<T,T>a)
{
    return dotProduct(a,a); 
}

template<class T>
LD length(pair<T,T>a)
{
    return sqrtl(lengthPow(a)); 
}

template<class T>
pair<T,T> operator+(pair<T,T>a, pair<T,T> b)
{
    T x =a.first + b.first;
    T y =a.second + b.second;
    return {x,y};
}

template<class T>
pair<T,T> operator-(pair<T,T>a, pair<T,T> b)
{
    T x =a.first - b.first;
    T y =a.second - b.second;
    return {x,y};
}


template<class T>
pair<T,T> operator*(pair<T,T>a, T b)
{
    T x =a.first *b;
    T y =a.second * b;
    return {x,y};
}

template<class T>
pair<T,T> operator/(pair<T,T>a, T b)
{
    T x =a.first / b;
    T y =a.second / b;
    return {x,y};
}

LD segPoint(PLD a, PLD b, PLD p)
{
    b = b-a;
    p = p-a;
    LD t= dotProduct(b,p)/dotProduct(b,b);
    cerr<<"in: "<<a.first<<' '<<a.second<<' '<<b.first<<' '<<b.second<<' '<<p.first<<' '<<p.second<<"\n";
    cerr<<"T: "<<t<<'\n';

    if( t < 0)
        t  = 0;
    if(t > 1)
        t = 1;


    PLD res = b * t;
    cerr<<"SEG: "<<res.first<<' '<<res.second<<"\n";
    return lengthPow(p - res);
} 


bool inCircle(PLD p, PLL o, LL r)
{
    return lengthPow(p-PLD{o}) < r*r + EPS;
}


int Ox, Oy, r;
PLL O;

const int MULTX[] = {0,1,0,-1};
const int MULTY[] = {1,0,-1,0};

bool outside(PLD s, LD dX, LD dY)
{
    if(PLD(O) > s and PLD(O) < (s + PLD{dX, dY})) {
        return false;
    }
    cerr<<O.first<<' '<<O.second<<"\n";
    cerr<<"TU\n";
    for(int i = 0; i < 4; ++i)
    {
        PLD n = s;
        n = n + PLD{MULTX[i] * dX, MULTY[i] * dY};
        LD dl = segPoint(s,n,O);
        cerr<<dl<<"\n";
        cerr<<s.first<<' '<<s.second<<' '<<n.first<<' '<<n.second<<"\n";
        if( dl <= r*r)
            return false;

        s = n;
        
    }
    
    return true;
}

LD reku(PLD s, LD dX, LD dY)
{
    cerr<<s.first<<' '<<s.second<<' '<<dX<<' '<<dY<<"\n";
    if( dX*dY< EPS || outside(s,dX,dY))
        return 0;

    cerr<<s.first<<' '<<s.second<<' '<<dX<<' '<<dY<<"\n";

    PLD s1 = s + PLD{dX,0};
    PLD s2 = s + PLD{0,dY};
    PLD s3 = s + PLD{dX,dY};

    if(inCircle(s,O,r) && inCircle(s1,O,r) && inCircle(s2,O,r) && inCircle(s3,O,r))
    {
        // cerr << s.first << " " << s.second << ' '<<dX<<"\n";
        return dX*dY;
    }

    dX /=2;
    dY /=2;
    return reku(s, dX,dY) + reku(s + PLD{dX,0}, dX, dY) 
         + reku(s + PLD{0,dY}, dX, dY) + reku(s + PLD{dX,dY}, dX, dY);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cout<<fixed<<setprecision(4);

    cin>>Ox>>Oy>>r;

    int a, bb, c, d;
    cin>> a >> bb >> c >> d;

    int t1 = min(a,c);
    int t2 = min(bb,d);
    int x = max(a,c) - t1;
    int y = max(bb,d) - t2;
    Ox -= t1;
    Oy -= t2;

    O = {Ox, Oy};
    cout<<reku(PLD{0,0},x,y)<<"\n";
    

}